<template lang="pug">
.registration
  h1.registration__title Регистрация
  Form(
    :items="fields"
    @input="input"
  )
  Error(v-if="error.status") {{ error.msg }}
  Button.registration__button(
    type="main"
    @click="submit"
  ) Зарегистрироваться
</template>

<script>
import Form from '@/components/parts/Form.vue'
import Button from '@/components/parts/Button.vue'
import Error from '@/components/parts/Error.vue'

export default {
  name: 'Registration',
  components: {
    Form,
    Button,
    Error
  },
  data() {
    return {
      fields: [
        {
          type: 'text',
          name: 'surname',
          placeholder: 'Иванов',
          text: 'Фамилия'
        },
        {
          type: 'text',
          name: 'email',
          placeholder: 'mail@mail.ru',
          text: 'Электронная почта'
        },
        {
          type: 'text',
          name: 'name',
          placeholder: 'Иван',
          text: 'Имя'
        },
        {
          type: 'text',
          name: 'phonenumber',
          placeholder: '89991234567',
          text: 'Номер телефона'
        },
        {
          type: 'text',
          name: 'patronymic',
          placeholder: 'Иванович',
          text: 'Отчество'
        },
        {
          type: 'text',
          name: 'place',
          placeholder: 'Красноярск',
          text: 'Населенный пункт'
        },
        {
          type: 'password',
          name: 'password',
          placeholder: '••••••',
          text: 'Пароль'
        },
        {
          type: 'password',
          name: 'password_confirm',
          placeholder: '••••••',
          text: 'Подтверждение пароля'
        },
      ],
      email: '',
      password: '',
      password_confirm: '',
      name: '',
      surname: '',
      patronymic: '',
      place: '',
      phonenumber: '',
      error: {
        status: false,
        msg: ''
      }
    }
  },
  methods: {
    input({ name, text }) {
      this[name] = text
    },
    async submit() {
      const { email, password, password_confirm, name, surname, patronymic, place, phonenumber } = this
      const correctPass = password === password_confirm
      if (email && name && surname && phonenumber) {
        const user = { email, username: email, password, name, surname, patronymic, place, phone_number: phonenumber }
        try {
          const response = await this.$store.dispatch('registration', user)
          this.$router.push({ name: 'Home' })
        } catch (e) {
          this.error.status = true
          this.error.msg = 'Такой пользователь уже существует'
        }
      } else {
        this.error.status = true
        this.error.msg = 'Проверьте все данные'
      }
    }
  }
}
</script>

<style lang="stylus" scoped>
.registration
  text-align: center
  &__title
    margin: 30px 0 10px 0
  &__button
    margin: 20px 0
</style>
